// CpDbfChange.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"

int _tmain(int argc, _TCHAR* argv[])
{
	bool bConsoleMsg = USE_CONSOLE_MSG;
	int nRetCode = NO_ERROR;
	int nFiles = 0;
	int nChangedFiles = 0;

	DWORD dwErrCode = NO_ERROR;
	_TCHAR szErrMsg[2*FORMAT_MESSAGE_MAX_WIDTH_MASK]; 
	CHAR szErrMsgDos[2*FORMAT_MESSAGE_MAX_WIDTH_MASK];

	int nCP = INITIAL_CP;
	int nCPCode = 0;
	char chNewCP = (char)nCPCode;
	char chBuff = '0';
	char achHeaderBuff[SIZE_FILE_HEADER];

	_TCHAR szInpDir[_MAX_PATH];
	_TCHAR szCurFile[_MAX_PATH];
	_TCHAR szTmpDir[_MAX_PATH];
	_TCHAR szCurExt[4];

	szInpDir[0] = (_TCHAR)NULL;
	szCurFile[0] = (_TCHAR)NULL;
	szTmpDir[0] = (_TCHAR)NULL;
	szCurExt[0] = (_TCHAR)NULL;
	
	HANDLE hFind = (HANDLE)NULL;
	HANDLE hFile = (HANDLE)NULL;
	WIN32_FIND_DATA FindFileData;
	DWORD dwCurrentFilePos = 0;
	DWORD dwBytes = 0;
	int anCpNums[29][2] = 
	{
		{437, 1},		// MS-DOS, U.S.A.
		{850, 2},		// MS-DOS, International
		{1252, 3},		// Windows, U.S.A & West European
		{10000, 4},		// Macintosh, U.S.A.
		{852, 100},		// MS-DOS, East European
		{866, 101},		// MS-DOS, Russian
		{865, 102},		// MS-DOS, Nordic
		{861, 103},		// MS-DOS, Iceland
		{895, 104},		// MS-DOS, Kamenicky (Czech)
		{620, 105},		// MS-DOS, Mazovia (Polish)
		{737, 106},		// MS-DOS, Greek
		{857, 107},		// MS-DOS, Turkey
		{863, 108},		// MS-DOS, Canada
		{950, 120},		// Windows, Traditional Chinese
		{949, 121},		// Windows, Korean (Hangul)
		{936, 122},		// Windows, Simplified Chinese
		{932, 123},		// Windows, Japanese (Shift-jis)
		{874, 124},		// Windows, Thai
		{10007, 150},	// Macintosh, Russian
		{10029, 151},	// Macintosh, East European
		{10006, 152},	// Macintosh, Greek
		{1250, 200},	// Windows, East European
		{1251, 201},	// Windows, Russian
		{1253, 203},	// Windows, Greek
		{1254, 202},	// Windows, Turkish
		{1255, 125},	// Windows, Hebrew (Only supported on Hebrew OS)
		{1256, 126},	// Windows, Arabic (Only supported on Arabic OS)
		{1257, 204},	// Windows, Baltic
		{0, 0}			// No codepage mark.
	};

	try
	{
		/////////////////////////////////////
		// Get args
		//
		if (argc == 1 || argc > 5)
		{
			ShowUsage(bConsoleMsg);
			return ERR_NUMBER_FATAL;
		}

		LPCTSTR lpCurChar = NULL;
		LPCTSTR pszTok = NULL;
		bool bContinue = true;
		int iTok = 1;
		while (iTok < argc)
		{
			pszTok = argv[iTok];
			if ((pszTok[0] == '-') || (pszTok[0] == '/') || (pszTok[0] == '\\')) 
			{
				switch (pszTok[1]) 
				{
					case 'd':
					case 'D':
						if (pszTok[2] == (_TCHAR)NULL)
						{
							lpCurChar = (LPCTSTR)argv[++iTok];
						}
						else
						{
							lpCurChar = (LPCTSTR)(pszTok + 2);
						}
						_tcscpy(szInpDir, lpCurChar);
						iTok++;
						break;
					case 'c':
					case 'C':
						if (pszTok[2] == (_TCHAR)NULL)
						{
							lpCurChar = (LPCTSTR)argv[++iTok];
						}
						else
						{
							lpCurChar = (LPCTSTR)(pszTok + 2);
						}
						nCP = _ttoi(lpCurChar);
						iTok++;
						break;
					case 'h':
					case 'H':
					case '?':
						ShowUsage(bConsoleMsg);
						bContinue = false;
						break;
					default:
						ShowUsage(bConsoleMsg);
						nRetCode = ERR_NUMBER_FATAL;
						bContinue = false;
						break;
				}
			}
			else
			{
				switch (iTok)
				{
					case 1:
						lpCurChar = (LPCTSTR)argv[iTok++];
						_tcscpy(szInpDir, lpCurChar);
						break;
					case 2:
						lpCurChar = (LPCTSTR)argv[iTok++];
						nCP = _ttoi(lpCurChar);
						break;
					default:
						ShowUsage(bConsoleMsg);
						nRetCode = ERR_NUMBER_FATAL;
						bContinue = false;
						break;
				}
			}
			if (!bContinue)
			{
				break;
			}
		}
		if (!bContinue)
		{
			return nRetCode;
		}

		/////////////////////////////////////
		// Get CODEPAGE (nCPCode & chNewCP)
		//
		int nCpMax = sizeof(anCpNums)/(2*sizeof(int));
		bool bCpFound = false;
		for(int nPos = 0; nPos < nCpMax; nPos++)
		{
			if (anCpNums[nPos][0] == nCP)
			{
				nCPCode = anCpNums[nPos][1];
				bCpFound = true;
				break;
			}
		}
		if (!bCpFound)
		{
			throw (ERR_CP_NUMBER);
		}
		chNewCP = (char)nCPCode; // get new CODEPAGE to files
		
		/////////////////////////////////////////////////
		// Check input directory (or GetCurrentDirectory)
		//
		if (_tcslen(szInpDir) == 0 && GetCurrentDirectory(_MAX_PATH, szInpDir) == 0)
		{
			if ((dwErrCode = GetLastError()) != NO_ERROR)
			{
				GetErrorMsg(_T("GetCurrentDirectory()"), dwErrCode, szErrMsg);
			}
			else
			{
				_tcscpy(szErrMsg ,UNEXPECT_ERR);
				_tcscat(szErrMsg, _T("GetCurrentDirectory()"));
			}
			throw (szErrMsg);
		}

		/////////////////////////////////////////////////
		// Check input directory
		//
		if (GetFileAttributes(szInpDir) == INVALID_FILE_ATTRIBUTES)
		{
			if ((dwErrCode = GetLastError()) != NO_ERROR)
			{
				GetErrorMsg(_T("GetFileAttributes()"), dwErrCode, szErrMsg);
				throw (szErrMsg);
			}
			else
			{
				_tcscpy(szErrMsg ,UNEXPECT_ERR);
				_tcscat(szErrMsg, _T("GetFileAttributes()"));
			}
			throw (szErrMsg);
		}

		/////////////////////////////////////////////////
		// Get mask to find files in InpDir
		//
		if (szInpDir[_tcslen(szInpDir)-1] != '\\')
		{
			_tcscat(szInpDir, _T("\\"));
		}
		_tcscpy(szTmpDir, szInpDir);
		_tcscat(szTmpDir, _T("*.*"));

		////////////////////////////////////////
		// Scan files in InpDir
		//
		memset(&FindFileData, 0, sizeof(WIN32_FIND_DATA));
		if ((hFind = FindFirstFile(szTmpDir, &FindFileData)) == INVALID_HANDLE_VALUE)
		{
			if ((dwErrCode = GetLastError()) != NO_ERROR)
			{
				GetErrorMsg(_T("FindFirstFile()"), dwErrCode, szErrMsg);
				throw (szErrMsg);
			}
			else
			{
				_tcscpy(szErrMsg ,UNEXPECT_ERR);
				_tcscat(szErrMsg, _T("FindFirstFile()"));
			}
			throw (szErrMsg);
		}

		LPCTSTR lpszDest = NULL;
		bool bFileFound = false;
		nFiles = 0;
		nChangedFiles = 0;

		do 
		{
			////////////////////////////////////////
			// Check file extention
			bFileFound = false;
			if (!(FindFileData.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY))
			{
				if ((lpszDest = _tcsrchr(FindFileData.cFileName, (int)'.')) != NULL 
						&& _tcslen(++lpszDest) == 3)
				{
					_tcscpy(szCurExt, lpszDest);
					if (_tcsstr(LIST_FILE_EXTS, _tcsupr(szCurExt)) != NULL)
					{
						bFileFound = true;
					}
				}
			}
			if (bFileFound)
			{
				////////////////////////////////////////
				// Open file
				//
				_tcscpy(szCurFile, szInpDir);
				_tcscat(szCurFile, FindFileData.cFileName);
				if ((hFile = CreateFile(szCurFile, 
						GENERIC_READ | GENERIC_WRITE, 
						(DWORD) 0, 
						NULL, 
						OPEN_EXISTING, 
						FILE_ATTRIBUTE_NORMAL, 
						(HANDLE) NULL)) == INVALID_HANDLE_VALUE)
				{
					hFile = (HANDLE)NULL;
					if ((dwErrCode = GetLastError()) != NO_ERROR)
					{
						GetErrorMsgEx(FindFileData.cFileName, 
							_T("CreateFile()"), dwErrCode, szErrMsg);
					}
					else
					{
						_stprintf(szErrMsg, 
							UNEXPECT_ERR_FL, FindFileData.cFileName, _T("CreateFile()")); 
					}
					CharToOem(szErrMsg, szErrMsgDos);
					cerr << szErrMsgDos << endl;
					nRetCode = ERR_NUMBER_FILE;
					goto scan_continue;
				}
				if (hFile != (HANDLE)NULL)
				{
					////////////////////////////////////////
					// Read header (first 32-bytes) of file
					//
					nFiles++;
					dwBytes = 0;
					if (!ReadFile(hFile, &achHeaderBuff, SIZE_FILE_HEADER, &dwBytes, NULL) 
							|| dwBytes != SIZE_FILE_HEADER)
					{
						if ((dwErrCode = GetLastError()) != NO_ERROR)
						{
							GetErrorMsgEx(FindFileData.cFileName, 
								_T("ReadFile()"), dwErrCode, szErrMsg);
						}
						else
						{
							_stprintf(szErrMsg, 
								UNEXPECT_ERR_FL, FindFileData.cFileName, _T("ReadFile()")); 
						}
						CharToOem(szErrMsg, szErrMsgDos);
						cerr << szErrMsgDos << endl;
						nRetCode = ERR_NUMBER_FILE;
						goto scan_continue;
					}

					////////////////////////////////////////
					//  First check that we have a FoxPro table...
					//
					if (achHeaderBuff[0] == (char)139 
							|| achHeaderBuff[0] == (char)203
							|| achHeaderBuff[30] != (char)0
							|| achHeaderBuff[31] != (char)0)
					{
						_stprintf(szErrMsg, 
							ERR_NOT_DBF_FRM, FindFileData.cFileName); 
						CharToOem(szErrMsg, szErrMsgDos);
						cerr << szErrMsgDos << endl;
						nRetCode = ERR_NUMBER_FILE;
						goto scan_continue;
					}

					////////////////////////////////////////
					// Get/check CODEPAGE of current file
					//
					if ((chBuff = achHeaderBuff[29]) != chNewCP)
					{
						////////////////////////////////////////
						// Write new CODEPAGE
						//
						dwCurrentFilePos = INVALID_SET_FILE_POINTER;
						if ((dwCurrentFilePos = SetFilePointer(hFile,
								POS_CP_IN_HEADER, NULL, FILE_BEGIN)) == INVALID_SET_FILE_POINTER)
						{
							if ((dwErrCode = GetLastError()) != NO_ERROR)
							{
								GetErrorMsgEx(FindFileData.cFileName, 
									_T("SetFilePointer()"), dwErrCode, szErrMsg);
							}
							else
							{
								_stprintf(szErrMsg, 
									UNEXPECT_ERR_FL, FindFileData.cFileName, _T("SetFilePointer()")); 
							}
							CharToOem(szErrMsg, szErrMsgDos);
							cerr << szErrMsgDos << endl;
							nRetCode = ERR_NUMBER_FILE;
							goto scan_continue;
						}
						dwBytes = 0;
						if (!WriteFile(hFile, (LPCVOID)&chNewCP, 1, &dwBytes, NULL) 
								|| dwBytes != 1)
						{
							if ((dwErrCode = GetLastError()) != NO_ERROR)
							{
								GetErrorMsgEx(FindFileData.cFileName, 
									_T("WriteFile()"), dwErrCode, szErrMsg);
							}
							else
							{
								_stprintf(szErrMsg, 
									UNEXPECT_ERR_FL, FindFileData.cFileName, _T("WriteFile()")); 
							}
							CharToOem(szErrMsg, szErrMsgDos);
							cerr << szErrMsgDos << endl;
							nRetCode = ERR_NUMBER_FILE;
							goto scan_continue;
						}
						nChangedFiles++;
					}
				}
	scan_continue:
				if (hFile != (HANDLE)NULL)
				{
					CloseHandle(hFile);
					hFile = (HANDLE)NULL;
				}
			}
		} while (FindNextFile(hFind, &FindFileData));
		if (hFind != (HANDLE)NULL)
		{
			FindClose(hFind);
			hFind = (HANDLE)NULL;
		}
	}
	catch (LPCTSTR lpszMsg)
	{
		if (bConsoleMsg)
		{
			CharToOem(lpszMsg, szErrMsgDos);
			cerr << szErrMsgDos << endl;
		}
		else
		{
			MessageBox(NULL, lpszMsg, ERR_CAPTION, MB_OK|MB_ICONERROR);
		}
		nRetCode = ERR_NUMBER_FATAL;
	}
	catch(...)
	{
		if (bConsoleMsg)
		{
			CharToOem(UNEXPECT_ERR_, szErrMsgDos);
			cerr << szErrMsgDos << endl;
		}
		else
		{
			MessageBox(NULL, UNEXPECT_ERR_, ERR_CAPTION, MB_OK|MB_ICONERROR);
		}
		nRetCode = ERR_NUMBER_FATAL;
	}
	if (hFile != (HANDLE)NULL)
	{
		CloseHandle(hFile);
		hFile = (HANDLE)NULL;
	}
	if (hFind != (HANDLE)NULL)
	{
		FindClose(hFind);
		hFind = (HANDLE)NULL;
	}
	return nRetCode;
}

void GetErrorMsg(LPCTSTR lpszFunction, DWORD dwErr, LPTSTR lpszMsg) 
{ 
    LPVOID lpMsgBuf;
    
	FormatMessage(
		FORMAT_MESSAGE_ALLOCATE_BUFFER | 
		FORMAT_MESSAGE_FROM_SYSTEM,
		NULL,
		dwErr,
		MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT),
		(LPTSTR)&lpMsgBuf,
		0, NULL);

	_stprintf(lpszMsg, 
       ERR_MSG_FRM, lpszFunction, dwErr, lpMsgBuf); 

	LocalFree(lpMsgBuf);
}

void GetErrorMsgEx(LPCTSTR lpszFile, LPCTSTR lpszFunction, DWORD dwErr, LPTSTR lpszMsg) 
{ 
    LPVOID lpMsgBuf;

	FormatMessage(
		FORMAT_MESSAGE_ALLOCATE_BUFFER | 
		FORMAT_MESSAGE_FROM_SYSTEM,
		NULL,
		dwErr,
		MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT),
		(LPTSTR)&lpMsgBuf,
		0, NULL);

	_stprintf(lpszMsg, 
       ERR_MSG_FRM_FL, lpszFile, lpszFunction, dwErr, lpMsgBuf); 

	LocalFree(lpMsgBuf);
}

void ShowUsage(bool bConsoleMsg = true)
{
    _TCHAR szErrMsg[2*FORMAT_MESSAGE_MAX_WIDTH_MASK]; 

	_tcscpy(szErrMsg, _T("\n"));
	_tcscat(szErrMsg, USAGE);
	_tcscat(szErrMsg, _T("\n"));
	_tcscat(szErrMsg, USAGE_STR);
	_tcscat(szErrMsg, _T("\n"));
	_tcscat(szErrMsg, _T("\n"));
	_tcscat(szErrMsg, ARG_DEFAULT);
	_tcscat(szErrMsg, _T("\n"));
	_tcscat(szErrMsg, ARG_DFLT_1);
	_tcscat(szErrMsg, _T("\n"));
	_tcscat(szErrMsg, ARG_DFLT_2);
	_tcscat(szErrMsg, _T("\n"));
	_tcscat(szErrMsg, _T("\n"));
	_tcscat(szErrMsg, ARG_EXAMP);
	_tcscat(szErrMsg, _T("\n"));
	_tcscat(szErrMsg, ARG_EXAMP_1);

	if (bConsoleMsg)
	{
		CHAR szErrMsgDos[2*FORMAT_MESSAGE_MAX_WIDTH_MASK];

		CharToOem(szErrMsg, szErrMsgDos);
		cout << szErrMsgDos << endl;
	}
	else
	{
		MessageBox(NULL, szErrMsg, INFO_CAPTION, MB_OK|MB_ICONINFORMATION);
	}
}
